part of 'generated.dart';

class ListRecentPaymentsByInvoiceIdVariablesBuilder {
  String invoiceId;
  Optional<int> _offset = Optional.optional(nativeFromJson, nativeToJson);
  Optional<int> _limit = Optional.optional(nativeFromJson, nativeToJson);

  final FirebaseDataConnect _dataConnect;  ListRecentPaymentsByInvoiceIdVariablesBuilder offset(int? t) {
   _offset.value = t;
   return this;
  }
  ListRecentPaymentsByInvoiceIdVariablesBuilder limit(int? t) {
   _limit.value = t;
   return this;
  }

  ListRecentPaymentsByInvoiceIdVariablesBuilder(this._dataConnect, {required  this.invoiceId,});
  Deserializer<ListRecentPaymentsByInvoiceIdData> dataDeserializer = (dynamic json)  => ListRecentPaymentsByInvoiceIdData.fromJson(jsonDecode(json));
  Serializer<ListRecentPaymentsByInvoiceIdVariables> varsSerializer = (ListRecentPaymentsByInvoiceIdVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<ListRecentPaymentsByInvoiceIdData, ListRecentPaymentsByInvoiceIdVariables>> execute() {
    return ref().execute();
  }

  QueryRef<ListRecentPaymentsByInvoiceIdData, ListRecentPaymentsByInvoiceIdVariables> ref() {
    ListRecentPaymentsByInvoiceIdVariables vars= ListRecentPaymentsByInvoiceIdVariables(invoiceId: invoiceId,offset: _offset,limit: _limit,);
    return _dataConnect.query("listRecentPaymentsByInvoiceId", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPayments {
  final String id;
  final String? workedTime;
  final EnumValue<RecentPaymentStatus>? status;
  final String staffId;
  final String applicationId;
  final String invoiceId;
  final Timestamp? createdAt;
  final Timestamp? updatedAt;
  final String? createdBy;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsApplication application;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoice invoice;
  ListRecentPaymentsByInvoiceIdRecentPayments.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  workedTime = json['workedTime'] == null ? null : nativeFromJson<String>(json['workedTime']),
  status = json['status'] == null ? null : recentPaymentStatusDeserializer(json['status']),
  staffId = nativeFromJson<String>(json['staffId']),
  applicationId = nativeFromJson<String>(json['applicationId']),
  invoiceId = nativeFromJson<String>(json['invoiceId']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  updatedAt = json['updatedAt'] == null ? null : Timestamp.fromJson(json['updatedAt']),
  createdBy = json['createdBy'] == null ? null : nativeFromJson<String>(json['createdBy']),
  application = ListRecentPaymentsByInvoiceIdRecentPaymentsApplication.fromJson(json['application']),
  invoice = ListRecentPaymentsByInvoiceIdRecentPaymentsInvoice.fromJson(json['invoice']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPayments otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPayments;
    return id == otherTyped.id && 
    workedTime == otherTyped.workedTime && 
    status == otherTyped.status && 
    staffId == otherTyped.staffId && 
    applicationId == otherTyped.applicationId && 
    invoiceId == otherTyped.invoiceId && 
    createdAt == otherTyped.createdAt && 
    updatedAt == otherTyped.updatedAt && 
    createdBy == otherTyped.createdBy && 
    application == otherTyped.application && 
    invoice == otherTyped.invoice;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, workedTime.hashCode, status.hashCode, staffId.hashCode, applicationId.hashCode, invoiceId.hashCode, createdAt.hashCode, updatedAt.hashCode, createdBy.hashCode, application.hashCode, invoice.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (workedTime != null) {
      json['workedTime'] = nativeToJson<String?>(workedTime);
    }
    if (status != null) {
      json['status'] = 
    recentPaymentStatusSerializer(status!)
    ;
    }
    json['staffId'] = nativeToJson<String>(staffId);
    json['applicationId'] = nativeToJson<String>(applicationId);
    json['invoiceId'] = nativeToJson<String>(invoiceId);
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    if (updatedAt != null) {
      json['updatedAt'] = updatedAt!.toJson();
    }
    if (createdBy != null) {
      json['createdBy'] = nativeToJson<String?>(createdBy);
    }
    json['application'] = application.toJson();
    json['invoice'] = invoice.toJson();
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPayments({
    required this.id,
    this.workedTime,
    this.status,
    required this.staffId,
    required this.applicationId,
    required this.invoiceId,
    this.createdAt,
    this.updatedAt,
    this.createdBy,
    required this.application,
    required this.invoice,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsApplication {
  final String id;
  final String staffId;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRole shiftRole;
  ListRecentPaymentsByInvoiceIdRecentPaymentsApplication.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  staffId = nativeFromJson<String>(json['staffId']),
  shiftRole = ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsApplication otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsApplication;
    return id == otherTyped.id && 
    staffId == otherTyped.staffId && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, staffId.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['staffId'] = nativeToJson<String>(staffId);
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsApplication({
    required this.id,
    required this.staffId,
    required this.shiftRole,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRole {
  final double? hours;
  final double? totalValue;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleRole role;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleShift shift;
  ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRole.fromJson(dynamic json):
  
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleRole.fromJson(json['role']),
  shift = ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleShift.fromJson(json['shift']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRole otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRole;
    return hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role && 
    shift == otherTyped.shift;
    
  }
  @override
  int get hashCode => Object.hashAll([hours.hashCode, totalValue.hashCode, role.hashCode, shift.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    json['shift'] = shift.toJson();
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRole({
    this.hours,
    this.totalValue,
    required this.role,
    required this.shift,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleRole otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleShift {
  final String id;
  final String title;
  final Timestamp? date;
  final String? locationAddress;
  ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  locationAddress = json['locationAddress'] == null ? null : nativeFromJson<String>(json['locationAddress']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleShift otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    locationAddress == otherTyped.locationAddress;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, locationAddress.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (locationAddress != null) {
      json['locationAddress'] = nativeToJson<String?>(locationAddress);
    }
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsApplicationShiftRoleShift({
    required this.id,
    required this.title,
    this.date,
    this.locationAddress,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsInvoice {
  final String id;
  final String invoiceNumber;
  final EnumValue<InvoiceStatus> status;
  final double amount;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceBusiness business;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceVendor vendor;
  final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceOrder order;
  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoice.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  invoiceNumber = nativeFromJson<String>(json['invoiceNumber']),
  status = invoiceStatusDeserializer(json['status']),
  amount = nativeFromJson<double>(json['amount']),
  business = ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceBusiness.fromJson(json['business']),
  vendor = ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceVendor.fromJson(json['vendor']),
  order = ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoice otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsInvoice;
    return id == otherTyped.id && 
    invoiceNumber == otherTyped.invoiceNumber && 
    status == otherTyped.status && 
    amount == otherTyped.amount && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, invoiceNumber.hashCode, status.hashCode, amount.hashCode, business.hashCode, vendor.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['invoiceNumber'] = nativeToJson<String>(invoiceNumber);
    json['status'] = 
    invoiceStatusSerializer(status)
    ;
    json['amount'] = nativeToJson<double>(amount);
    json['business'] = business.toJson();
    json['vendor'] = vendor.toJson();
    json['order'] = order.toJson();
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoice({
    required this.id,
    required this.invoiceNumber,
    required this.status,
    required this.amount,
    required this.business,
    required this.vendor,
    required this.order,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceBusiness {
  final String id;
  final String businessName;
  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceBusiness otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceBusiness({
    required this.id,
    required this.businessName,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceVendor {
  final String id;
  final String companyName;
  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceVendor otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceOrder {
  final String id;
  final String? eventName;
  final String? location;
  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceOrder otherTyped = other as ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    location == otherTyped.location;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, location.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    return json;
  }

  ListRecentPaymentsByInvoiceIdRecentPaymentsInvoiceOrder({
    required this.id,
    this.eventName,
    this.location,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdData {
  final List<ListRecentPaymentsByInvoiceIdRecentPayments> recentPayments;
  ListRecentPaymentsByInvoiceIdData.fromJson(dynamic json):
  
  recentPayments = (json['recentPayments'] as List<dynamic>)
        .map((e) => ListRecentPaymentsByInvoiceIdRecentPayments.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdData otherTyped = other as ListRecentPaymentsByInvoiceIdData;
    return recentPayments == otherTyped.recentPayments;
    
  }
  @override
  int get hashCode => recentPayments.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['recentPayments'] = recentPayments.map((e) => e.toJson()).toList();
    return json;
  }

  ListRecentPaymentsByInvoiceIdData({
    required this.recentPayments,
  });
}

@immutable
class ListRecentPaymentsByInvoiceIdVariables {
  final String invoiceId;
  late final Optional<int>offset;
  late final Optional<int>limit;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  ListRecentPaymentsByInvoiceIdVariables.fromJson(Map<String, dynamic> json):
  
  invoiceId = nativeFromJson<String>(json['invoiceId']) {
  
  
  
    offset = Optional.optional(nativeFromJson, nativeToJson);
    offset.value = json['offset'] == null ? null : nativeFromJson<int>(json['offset']);
  
  
    limit = Optional.optional(nativeFromJson, nativeToJson);
    limit.value = json['limit'] == null ? null : nativeFromJson<int>(json['limit']);
  
  }
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByInvoiceIdVariables otherTyped = other as ListRecentPaymentsByInvoiceIdVariables;
    return invoiceId == otherTyped.invoiceId && 
    offset == otherTyped.offset && 
    limit == otherTyped.limit;
    
  }
  @override
  int get hashCode => Object.hashAll([invoiceId.hashCode, offset.hashCode, limit.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['invoiceId'] = nativeToJson<String>(invoiceId);
    if(offset.state == OptionalState.set) {
      json['offset'] = offset.toJson();
    }
    if(limit.state == OptionalState.set) {
      json['limit'] = limit.toJson();
    }
    return json;
  }

  ListRecentPaymentsByInvoiceIdVariables({
    required this.invoiceId,
    required this.offset,
    required this.limit,
  });
}

